



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>字符串匹配的KMP算法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">字符串匹配的KMP算法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 01:58:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>~~~摘录 来源：<a href="http://www.ruanyifeng.com/blog/2013/05/Knuth%E2%80%93Morris%E2%80%93Pratt_algorithm.html" rel="external nofollow noreferrer">阮一峰</a>~~~</p>
<p><a href="http://en.wikipedia.org/wiki/String_searching_algorithm" rel="external nofollow noreferrer">字符串匹配</a>是计算机的基本任务之一。</p>
<p>举例来说，有一个字符串&rdquo;BBC ABCDAB ABCDABCDABDE&rdquo;，我想知道，里面是否包含另一个字符串&rdquo;ABCDABD&rdquo;？</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10203628-f9eddfa1d78b408a8d9c14a35f0e2c7c.jpg" /></p>
<p>许多算法可以完成这个任务，<a href="http://en.wikipedia.org/wiki/Knuth%E2%80%93Morris%E2%80%93Pratt_algorithm" rel="external nofollow noreferrer">Knuth-Morris-Pratt算法</a>（简称KMP）是最常用的之一。它以三个发明者命名，起头的那个K就是著名科学家Donald Knuth。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10203735-fa2717c40a7b4b85b03106c82d520c22.jpg" /></p>
<p>这种算法不太容易理解，网上有很多<a href="http://www.google.com/search?q=Knuth-Morris-Pratt+algorithm" rel="external nofollow noreferrer">解释</a>，但读起来都很费劲。直到读到<a href="http://jakeboxer.com/blog/2009/12/13/the-knuth-morris-pratt-algorithm-in-my-own-words/" rel="external nofollow noreferrer">Jake Boxer</a>的文章，我才真正理解这种算法。下面，我用自己的语言，试图写一篇比较好懂的KMP算法解释。</p>
<p>1.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10203839-2c09830ec72044e987e6367e72420b7c.png" /></p>
<p>首先，字符串&rdquo;BBC ABCDAB ABCDABCDABDE&rdquo;的第一个字符与搜索词&rdquo;ABCDABD&rdquo;的第一个字符，进行比较。因为B与A不匹配，所以搜索词后移一位。</p>
<p>2.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10203901-e4a048a4e9cd419eb3a91dcc34427412.png" /></p>
<p>因为B与A不匹配，搜索词再往后移。</p>
<p>3.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204004-17efc5f4e682411bb9a40f18b695bf6b.png" /></p>
<p>就这样，直到字符串有一个字符，与搜索词的第一个字符相同为止。</p>
<p>4.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204054-2e8f66a7a24348f39a358ad149cbff59.png" /></p>
<p>接着比较字符串和搜索词的下一个字符，还是相同。</p>
<p>5.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204123-3a4187a281c944989d8fc59601864a5e.png" /></p>
<p>直到字符串有一个字符，与搜索词对应的字符不相同为止。</p>
<p>6.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204209-7ef251839cfa498cb4393f3268bed876.png" /></p>
<p>这时，最自然的反应是，将搜索词整个后移一位，再从头逐个比较。这样做虽然可行，但是效率很差，因为你要把&rdquo;搜索位置&rdquo;移到已经比较过的位置，重比一遍。</p>
<p>7.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204308-1482716eb9c04fd385c8e1671877f1b8.png" /></p>
<p>一个基本事实是，当空格与D不匹配时，你其实知道前面六个字符是&rdquo;ABCDAB&rdquo;。KMP算法的想法是，设法利用这个已知信息，不要把&rdquo;搜索位置&rdquo;移回已经比较过的位置，继续把它向后移，这样就提高了效率。</p>
<p>8.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204346-c5cc08429a7844aab6bb39e3e1921288.png" /></p>
<p>怎么做到这一点呢？可以针对搜索词，算出一张《部分匹配表》（Partial Match Table）。这张表是如何产生的，后面再介绍，这里只要会用就可以了。</p>
<p>9.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204421-db4b31138ea44f11aa5137a8bb54f44d.png" /></p>
<p>已知空格与D不匹配时，前面六个字符&rdquo;ABCDAB&rdquo;是匹配的。查表可知，最后一个匹配字符B对应的&rdquo;部分匹配值&rdquo;为2，因此按照下面的公式算出向后移动的位数：</p>
<p><em>　　移动位数</em><em> = </em><em>已匹配的字符数</em><em> &ndash; </em><em>对应的部分匹配值</em></p>
<p>因为 6 &ndash; 2 等于4，所以将搜索词向后移动4位。</p>
<p>10.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204506-e4ef98c844d24a49a7e2fb4c85458ce2.png" /></p>
<p>因为空格与Ｃ不匹配，搜索词还要继续往后移。这时，已匹配的字符数为2（&rdquo;AB&rdquo;），对应的&rdquo;部分匹配值&rdquo;为0。所以，移动位数 = 2 &ndash; 0，结果为 2，于是将搜索词向后移2位。</p>
<p>11.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204536-140f54c53e5b4a77a94061a72b55d048.png" /></p>
<p>因为空格与A不匹配，继续后移一位。</p>
<p>12.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204606-198d3dcf19ff45eb8b8b9c98662bba90.png" /></p>
<p>逐位比较，直到发现C与D不匹配。于是，移动位数 = 6 &ndash; 2，继续将搜索词向后移动4位。</p>
<p>13.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204644-01f044b6df714402aa05d09ad40c1857.png" /></p>
<p>逐位比较，直到搜索词的最后一位，发现完全匹配，于是搜索完成。如果还要继续搜索（即找出全部匹配），移动位数 = 7 &ndash; 0，再将搜索词向后移动7位，这里就不再重复了。</p>
<p>14.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204716-74a02f390eab4f3b99c5aca660c4df15.png" /></p>
<p>下面介绍《部分匹配表》是如何产生的。</p>
<p>首先，要了解两个概念：&rdquo;前缀&rdquo;和&rdquo;后缀&rdquo;。 &ldquo;前缀&rdquo;指除了最后一个字符以外，一个字符串的全部头部组合；&rdquo;后缀&rdquo;指除了第一个字符以外，一个字符串的全部尾部组合。</p>
<p>15.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204745-c564a183417048a192c5411232a391d4.png" /></p>
<p>&ldquo;部分匹配值&rdquo;就是&rdquo;前缀&rdquo;和&rdquo;后缀&rdquo;的最长的共有元素的长度。以&rdquo;ABCDABD&rdquo;为例，</p>
<p><em>　　－　</em><em>&rdquo;A&rdquo;</em><em>的前缀和后缀都为空集，共有元素的长度为</em><em>0</em><em>；</em></p>
<p><em>－　</em><em>&rdquo;AB&rdquo;</em><em>的前缀为</em><em>[A]</em><em>，后缀为</em><em>[B]</em><em>，共有元素的长度为</em><em>0</em><em>；</em></p>
<p><em>－　</em><em>&rdquo;ABC&rdquo;</em><em>的前缀为</em><em>[A, AB]</em><em>，后缀为</em><em>[BC, C]</em><em>，共有元素的长度</em><em>0</em><em>；</em></p>
<p><em>－　</em><em>&rdquo;ABCD&rdquo;</em><em>的前缀为</em><em>[A, AB, ABC]</em><em>，后缀为</em><em>[BCD, CD, D]</em><em>，共有元素的长度为</em><em>0</em><em>；</em></p>
<p><em>－　</em><em>&rdquo;ABCDA&rdquo;</em><em>的前缀为</em><em>[A, AB, ABC, ABCD]</em><em>，后缀为</em><em>[BCDA, CDA, DA, A]</em><em>，共有元素为</em><em>&rdquo;A&rdquo;</em><em>，长度为</em><em>1</em><em>；</em></p>
<p><em>－　</em><em>&rdquo;ABCDAB&rdquo;</em><em>的前缀为</em><em>[A, AB, ABC, ABCD, ABCDA]</em><em>，后缀为</em><em>[BCDAB, CDAB, DAB, AB, B]</em><em>，共有元素为</em><em>&rdquo;AB&rdquo;</em><em>，长度为</em><em>2</em><em>；</em></p>
<p><em>－　</em><em>&rdquo;ABCDABD&rdquo;</em><em>的前缀为</em><em>[A, AB, ABC, ABCD, ABCDA, ABCDAB]</em><em>，后缀为</em><em>[BCDABD, CDABD, DABD, ABD, BD, D]</em><em>，共有元素的长度为</em><em>0</em><em>。</em></p>
<p>16.</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/572464/201310/10204821-dc8904287c904ba8b9f74a3617507975.png" /></p>
<p>&ldquo;部分匹配&rdquo;的实质是，有时候，字符串头部和尾部会有重复。比如，&rdquo;ABCDAB&rdquo;之中有两个&rdquo;AB&rdquo;，那么它的&rdquo;部分匹配值&rdquo;就是2（&rdquo;AB&rdquo;的长度）。搜索词移动的时候，第一个&rdquo;AB&rdquo;向后移动4位（字符串长度-部分匹配值），就可以来到第二个&rdquo;AB&rdquo;的位置。</p>
<p>（完）</p>
<p>~~~摘录~~~</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pjy649.html">报错：MySQL check the manual that corresponds to your MySQL server version for the right syntax</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93rorg9.html">【转】C&plus;&plus;多态性</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jok7eq.html">angular-ui-bootstrap的进度条问题及解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd6mkj8.html">subprocess使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yj12eq.html">第一个jave程序-helloworld</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vljm38.html">Android开发UI之自定义控件的皮肤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn10xmk8.html">heritrix 相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j07v10q.html">Quartz&period;Net任务调度框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn411pq.html">linux负载均衡</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpljxq.html">Codeforces243C-Colorado Potato Beetle&lpar;离散化&plus;bfs&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1p51m9.html">JavaScript之面向对象学九&lpar;原型式继承和寄生式继承&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zgr639.html">Study notes for Sparse Coding</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jw6ox8.html">UVA 10622 - Perfect P-th Powers&lpar;数论&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj0vdl8.html">基于php&lpar;Thinkphp&rpar;&plus;jquery 实现ajax多选，反选，不选   删除数据       新手学习向</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rkdez8.html">python 获取随机字母</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11vglq.html">利用正则&plus;requests爬取猫眼电影信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rr0o48.html">ASP&period;NET登录验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gyzjeq.html">CF 910 C&period; Minimum Sum</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj63369.html">Path expected for join&excl;错误处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2553rq.html">python 解析与生成xml</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4me65q.html">对一个二维数组进行升序排列a&lbrack;0&rsqb;&lbrack;1&rsqb;为最小</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gd1579.html">用PHP实现浏览器点击下载各种格式文档的方法详解【txt apk等等】</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gd1zl9.html">MRPT图形界面</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdoe3x8.html">Adobe Photoshop CC &lpar;32&sol;64位&rpar; 绿色精简版</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gdmw49.html">C&plus;&plus; STL之vector用法总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k5p158.html">stst</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql5j068.html">Eclipse 快捷键  （应用中自己总结）</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q20jpw9.html">使用扫描二维码打开app</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1jv72q.html">关于HTML5你必须知道的28个新特性&comma;新技巧以及新技术</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pxmn4q.html">在Eclipse中，如何把一个java项目变成web项目</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
